import React, { PureComponent } from "react";
import { connect } from "dva";
import AlloyFinger from "alloyfinger/react/AlloyFinger";
// import { message } from "antd";

class BotSar extends PureComponent {

  renderMaterial = () => {
    const { editModel:{allMaterialByGroup }} = this.props;
    const { allMaterial, scale, assetList ,indexkey} = this.props;
    return allMaterial.map((item, index) => {
      
      let uiResult = null;
      let defaultZIndex = 2;
      let key = item.assetName;
      // let s = item.scale[0];
      let x = item.position[0];
      let y = item.position[1];
      // let aX = item.anchor[0];
      // let aY = item.anchor[1];
      let w = item["originSize"][0];
      let h = item["originSize"][1];
      // let r = item.rotate;
      let allGroup = allMaterialByGroup[indexkey][index];
      let starX=allGroup.position[0]
      
      let starY=allGroup.position[1]
      let currentScale=1
      let currentRotate=0
      if(item.distScale !== undefined){
        currentScale=item.distScale[0]
      }
      if(item.distRotate !== undefined){
        currentRotate=item.distRotate
      }
      
      // let parcel=allGroup.position[0]
      // if(feg===0 && w<allGroup["originSize"][0]){
      //   parcel=parcel*2
      // }
      const innerStyle = {
        position: "absolute",
        left:0,
        top:0,
        width: `${w}px`,
        height: `${h}px`,
        transform: `translate(${x-starX}px, ${y-starY}px) rotate(${currentRotate}deg) scale(${currentScale})`,
      },
        containerStyle = {
          position: "absolute",
          zIndex: item.zIndex + defaultZIndex,
          left: 0,
          top: 0,
          transform: `scale(${scale})`,
          opacity: `${item.transparence}`,

          transformOrigin: "0px 0px 0px",
        },
        innerStylebor = {
          position: "absolute",
          left: `${-allGroup.anchor[0]}px`,
          top: `${-allGroup.anchor[1]}px`,
          width: `${allGroup["originSize"][0]}px`,
          height: `${allGroup["originSize"][1]}px`,
          transformOrigin: `${allGroup.anchor[0]}px ${allGroup.anchor[1]}px`,
          transform: `translate(${allGroup.position[0]}px, ${allGroup.position[1]}px) rotate(${allGroup.rotate}deg) scale(${allGroup.scale[0]})`,
          // border: "4px dashed  red",
          overflow: "hidden",
          // pointerEvents: 'none'
        };
      switch (item.type) {
        case 1:
          uiResult = (
            <div style={containerStyle} key={key}>
              <div style={innerStylebor}>
                  <AlloyFinger>
                    <img
                      className="innerStyle"
                      style={innerStyle}
                      src={assetList[key]}
                      alt="asset"
                    />
                  </AlloyFinger>
                </div>
            </div>
          );
          break;
        case 2:
        case 3:
          break;

        default:
          uiResult = null;
          break;
      }

      return uiResult;
    });
  };

  render() {
    return <div>{this.renderMaterial()}</div>;
  }
}

const stateToProps = (state) => ({
  editModel: state["edit"],
});

export default connect(stateToProps)(BotSar);
