import commonReducers from "utils/commonReducers";
import { getTemplateInfo, submitRender } from "services/root";
import env from "@/env";
import { sourceRequest } from "utils/request";
// import Cookies from "js-cookie";
import ParseConfig from "utils/lib/ParseConfig";
import router from "umi/router";

export default {
  namespace: "edit",
  state: {
    isShowMaterialListModel: false,
    isShowVideoClip: false,
    isFocusText: false,
    pageLoading: false,
    editWindowCurrentIndex: 1,
    isOpenMaterialList: false,
    editWindowWithPosition: true,
    horizontalVersion: false,
    parseManage: null,
    currentTemplateInfo: null,
    allMaterialByGroup: {},
    allOriginMaterialByGroup: {},
    isShowOriginMaterialContainer: false,
    backgroundImageList: {},
    prospectImageList: {},
    assetList: {},
    editorContainerHeight: 0,
    currentGroup: {},
    currentGroupIndex: "1",
    currentMaterialIndex: -1,
    materialDomList: {},
    currentTransformDomRef: null,
    isShowCurrentTransform: false,
    totalTime: 0,
    showStyleInfo: {
      groupHeight: 0,
      containerHeight: 0,
      containerWidth: 0,
    },
    isShowCorpImage: false,
    scale: {
      group: 1,
      container: 1,
    },

    groupKeys: null,
    groups: null,
    ui_group: null,
    check: "1",
    templateHeight: null,
    templateWidth: null,
    ratio: 0,
    color_flag: false,
    reacdTextObj: {},
    reacdTextIndex: null,
    txtNum: 0,
    spanLoading: false,
    videoupload: {},
    templateId: 0,
    recadTextModalItem: {},
    fontcolorchange: {},
    countFlagApply: 0,
    keyboardStyle: 0,
    Listentoseehigh: {
      // position: "fixed",
      // width: "100%",
      // bottom: "30px",
    },
  },
  subscriptions: {
    setup({ dispatch, history }) {
      return history.listen(({ pathname, search, query }) => {
        if (pathname === "/edit" && !search) {
          router.push("/");
        }
        // if (pathname !== "/editor") {
        //   if (localStorage.getItem(PAGE_LOADING_TYPE) === "1") {
        //     window.location.reload();
        //     localStorage.setItem(PAGE_LOADING_TYPE, "0");
        //   }
        // }
        if (pathname === "/edit" && search) {
          const id = query.templateId;
          dispatch({
            type: "fetch",
            payload: {
              id,
              act:"detail",
            },
          });
        }
        if (pathname === "/compile" && search) {
          // console.log(1);
          const id = query.templateId;
          dispatch({
            type: "fetch",
            payload: {
              id,
              act:"detail",
            },
          });
        }
      });
    },
  },
  effects: {
    *fetch({ payload }, { call, put }) {
      const { success, data } = yield call(getTemplateInfo, payload);
      if (success) {

        const { detail } = data,
          configUrl = detail.config_url;
        const { success: getConfigSuccess, data: configData } = yield call(
          sourceRequest,
          configUrl,
        );
        if (getConfigSuccess) {
          const parseManage = new ParseConfig(configData),
            horizontalVersion = parseManage.horizontalVersion,
            groups = parseManage["groups"],
            groupKeys = parseManage["groupKeys"],
            backgroundImageList = JSON.parse(detail["bg_list"]),
            prospectImageList = JSON.parse(detail["fg_list"]),
            assetList = JSON.parse(detail["asset_list"]),
            sourceHost = env.sourceHost,
            allMaterialByGroup = {};

          let group = {},
            container = {},
            currentGroup = null,
            currentGroupIndex,
            groupHeight = 150,
            key,
            allOriginMaterialByGroup = {},
            windowHeight = window.innerHeight - 300;

          if (horizontalVersion) {
            windowHeight -= 150;
          }

          group = parseManage.getWidthScale(groupHeight);
          container = parseManage.getWidthScale(windowHeight);
          // console.log(groups)

          for (key in backgroundImageList) {
            if (backgroundImageList.hasOwnProperty(key)) {
              // backgroundImageList[key] = sourceHost + backgroundImageList[key];
              backgroundImageList[key] = backgroundImageList[key];
            }
          }

          for (key in prospectImageList) {
            if (prospectImageList.hasOwnProperty(key)) {
              // prospectImageList[key] = sourceHost + prospectImageList[key];
              prospectImageList[key] = prospectImageList[key];
            }
          }

          for (key in assetList) {
            if (assetList.hasOwnProperty(key)) {
              // assetList[key] = sourceHost + assetList[key];
              assetList[key] = assetList[key];
              let fileFormat = key.substring(key.lastIndexOf(".") + 1).toUpperCase();
              if (fileFormat === "MP4" || fileFormat === "MOV") {
                assetList[key] += "?x-oss-process=video/snapshot,t_0";
              }
            }
          }

          for (key in groups) {
            if (groups.hasOwnProperty(key)) {
              const group = groups[key];
              allMaterialByGroup[key] = JSON.parse(JSON.stringify(group["allMaterial"]));
              allOriginMaterialByGroup[key] = JSON.parse(JSON.stringify(group["allMaterial"]));
              if (!currentGroup) {
                currentGroupIndex = key;
                currentGroup = {
                  [key]: allMaterialByGroup[key],
                };
              }
            }
          }
          let ratio = 0;
          const innerHeight = window.innerHeight;
          // alert(innerHeight)
          const feg =
            Number(parseManage.templateHeight) > Number(parseManage.templateWidth) ? 0 : 1;
          let guzhi = 0;
          if (innerHeight <= 568 && feg === 0) {
            ratio = 250 / Number(parseManage.templateHeight);
            guzhi = 250;
          } else if (innerHeight <= 568 && feg === 1) {
            ratio = 240 / Number(parseManage.templateWidth);
            guzhi = 240;
          } else if (innerHeight <= 667 && innerHeight > 568 && feg === 0) {
            ratio = 350 / Number(parseManage.templateHeight);
            guzhi = 350;
          } else if (innerHeight <= 667 && innerHeight > 568 && feg === 1) {
            ratio = 300 / Number(parseManage.templateWidth);
            guzhi = 300;
          } else if (innerHeight <= 736 && innerHeight > 667 && feg === 0) {
            ratio = 420 / Number(parseManage.templateHeight);
            guzhi = 420;
          } else if (innerHeight <= 736 && innerHeight > 667 && feg === 1) {
            ratio = 320 / Number(parseManage.templateWidth);
            guzhi = 320;
          } else if (innerHeight <= 813 && innerHeight > 736 && feg === 0) {
            ratio = 495 / Number(parseManage.templateHeight);
            guzhi = 495;
          } else if (innerHeight <= 813 && innerHeight > 736 && feg === 1) {
            ratio = 320 / Number(parseManage.templateWidth);
            guzhi = 320;
          }
          // console.log(parseManage.templateWidth, parseManage.templateHeight);
          // console.log(allMaterialByGroup)
          yield put({
            type: "save",
            payload: {
              parseManage: parseManage,
              currentTemplateInfo: detail,
              horizontalVersion: parseManage.horizontalVersion,
              editorContainerHeight: groupHeight + 30,
              totalTime: parseManage.getTotalTime(),
              backgroundImageList: backgroundImageList,
              prospectImageList: prospectImageList,
              assetList: assetList,
              currentGroup: currentGroup,
              currentGroupIndex: currentGroupIndex,
              allMaterialByGroup: allMaterialByGroup,
              allOriginMaterialByGroup: allOriginMaterialByGroup,
              currentMaterialIndex: -1,
              editWindowCurrentIndex: 1,
              isOpenMaterialList: false,
              editWindowWithPosition: true,
              isChangeFontSize: false,
              showStyleInfo: {
                groupHeight: groupHeight,
                groupWidth: group.width,
                containerHeight: windowHeight,
                containerWidth: container.width,
              },
              scale: {
                group: group.scale,
                container: container.scale,
              },
              groupKeys: groupKeys,
              groups: groups,
              ui_group: configData.ui_group,
              templateHeight: parseManage.templateHeight,
              templateWidth: parseManage.templateWidth,
              // ratio: 190 / Number(parseManage.templateWidth),
              ratio: ratio,
              templateId: payload.id,
              countFlagApply: 0,
              pageLoading: false,
              isShowVideoClip: false,
              // bili:
              //   Number(parseManage.templateWidth) > Number(parseManage.templateHeight)
              //     ? 140
              //     : Number(parseManage.templateWidth) === Number(parseManage.templateHeight)
              //     ? 120
              //     : 60,
                  bili:
                Number(parseManage.templateWidth) > Number(parseManage.templateHeight)
                  ? 78
                  : Number(parseManage.templateWidth) === Number(parseManage.templateHeight)
                  ? 120
                  : 108,
              feg: feg,
              guzhi: guzhi,
              check: "1",
            },
          });
        }
      }
    },
    *submitRender({ payload }, { call, put }) {
      const { json } = payload;
      const { success, data } = yield call(submitRender, json);
      console.log(router);
      if (window.location.pathname === "/compile") {
        if (success) {
          // router.push(`/videoPlay?orderId=${data.res.data["orderId"]}`);
          router.push({
            pathname:"/videoPlay",
            state:{
              recordId:data.record_id,
              orderId:data.order_id,
              videoUrl:data.video_url,
            }
          });
        }
      }
    },
  },
  reducers: {
    ...commonReducers,
    changeBottomTab(state, { payload }) {
      return {
        ...state,
        ...payload,
      };
    },
    uploadPhoto(state, { payload }) {
      let assetList = { ...state.assetList, ...payload };
      return {
        ...state,
        assetList,
        countFlagApply: state.countFlagApply + 1,
      };
    },
    onPressMove(state, { payload }) {
      let check = state.check;
      let groups = state.groups;
      groups[check].allMaterial.splice(payload.index, 1, payload.obj);
      return {
        ...state,
        groups,
        color_flag: payload.color_flag,
        // countFlagApply: state.countFlagApply + 1,
      };
    },
    onRotate(state, { payload }) {
      let check = state.check;
      let groups = state.groups;
      groups[check].allMaterial.splice(payload.index, 1, payload.obj);
      return {
        ...state,
        groups,
        color_flag: payload.color_flag,
        // countFlagApply: state.countFlagApply + 1,
      };
    },
    handleTextChangeItem(state, { payload }) {
      let check = state.check;
      let groups = state.groups;
      groups[check].allMaterial.splice(payload.index, 1, payload.obj);
      // console.log(groups);
      let countFlagApply = state.countFlagApply;
      if (payload.countFlagApply) {
        countFlagApply = payload.countFlagApply;
      }
      // console.log(groups)
      return {
        ...state,
        groups,
        reacdTextObj: payload.obj,
        reacdTextIndex: payload.index,
        countFlagApply: countFlagApply,
      };
    },
    changecolorflag(state, { payload }) {
      // console.log(state.countFlagApply)
      return {
        ...state,
        ...payload,
      };
    },
    chaneWordColor(state, { payload }) {
      let reacdTextObj = state.reacdTextObj;
      let reacdTextIndex = state.reacdTextIndex;
      let nameKey = payload.nameKey;
      reacdTextObj.fontSetting[nameKey] = payload[nameKey];
      let check = state.check;
      let groups = state.groups;
      groups[check].allMaterial.splice(reacdTextIndex, 1, reacdTextObj);
      return { ...state, countFlagApply: state.countFlagApply + 1 };
    },
    wenbenClick(state, { payload }) {
      return {
        ...state,
        ...payload,
      };
    },
    changeSpanLoading(state, { payload }) {
      return {
        ...state,
        ...payload,
      };
    },
    videoupload(state, { payload }) {
      return {
        ...state,
        ...payload,
      };
    },
    vediodata(state, { payload }) {
      let saveData = state.videoupload;
      let a = saveData.assetName;
      let b = saveData.url;
      let obg = { [a]: b };
      let assetList = { ...state.assetList, ...obg };
      let check = state.check;
      let groups = state.groups;
      let material = saveData.material;
      material["videoClip"] = payload.data;
      groups[check].allMaterial.splice(saveData.index, 1, material);
      return {
        ...state,
        assetList,
        groups,
      };
    },
    recadTextModal(state, { payload }) {
      // console.log(payload)
      return {
        ...state,
        ...payload,
      };
    },
    recakeybrop(state, { payload }) {
      return {
        ...state,
        ...payload,
      };
    },
  },
};
