import commonReducers from "utils/commonReducers";
import { getData, getTagData } from "services/templateList";
import { getToken } from "services/root";
import Cookies from "js-cookie";

export default {
  namespace: "list",
  state: {
    list: [],
    parseManage: null,
    total: 0,
    current_page: 1,
    tagList: [],
    template_group: "",
    tabindex: 0,
    startY: 0,
  },
  subscriptions: {
    setup({ dispatch, history }) {
      return history.listen(({ pathname }) => {
        if (pathname === "/" && !Cookies.get("__token__")) {
          dispatch({
            type: "getTemplateList",
            payload: {
              page_size: 10,
              page: 1,
              category_id:""
            },
          });
          dispatch({
            type: "fetchTag",
          });
        }
      });
    },
  },
  effects: {
    *fetch({ payload }, { call, put }) {
      const { success, data } = yield call(getToken, payload);
      if (success) {
        Cookies.set("__token__", data.token);
        Cookies.set("SOURCE_URL", data["source_url"]);
        window.location.reload();
      }
    },
    *getTemplateList({ payload }, { call, put }) {
      let template_group = "";
      if (payload.template_group !== undefined) {
        template_group = payload.template_group;
      }
      const { success, data } = yield call(getData, payload);
      if (success) {
        yield put({
          type: "save",
          payload: {
            list: data.list || [],
            total: data.total,
            current_page: data.current_page,
            template_group: template_group,
          },
        });
      }
    },
    *pagelistpushdata({ payload }, { call, put }) {
      let template_group = "";
      if (payload.template_group !== undefined) {
        template_group = payload.template_group;
      }
      const { success, data } = yield call(getData, payload);
      if (success) {
        yield put({
          type: "save",
          payload: {
            // list: data.list || [],
            total: data.total,
            current_page: data.current_page,
            template_group: template_group,
          },
        });
        yield put({
          type: "pushlist",
          payload: {
            list: data.list || [],
          },
        });
      }
    },
    *fetchTag({ payload }, { call, put }) {
      const { success, data } = yield call(getTagData, payload);
      if (success) {
        data.category.unshift({category_id: "", category_name: "全部"})
        yield put({
          type: "save",
          payload: {
            tagList: data.category || [],
          },
        });
      }
    },
  },
  reducers: {
    ...commonReducers,
    pushlist(state, { payload }) {
      let list = [...state.list, ...payload.list];
      // let list = [...payload.list];
      // if(payload.list.length !==0 ){
      //   list=[...state.list.push.apply(state.list,payload.list)]
      // }
      // console.log(state.list);
      return {
        ...state,
        list,
      };
    },
  },
};
