import React, { PureComponent } from "react";
import styles from "./index.less";
import CommonPreview from "components/EditGroups/Group/CommonPreview";

class Preview extends PureComponent {
  maxWidth = 454;
  groupHeight = 255;

  getContainerStyle = (options) => {
    const { isShow, left, top } = this.props,
      style = {
        left: `${left}px`,
        top: `${top}px`,
        visibility: isShow ? "visible" : "hidden",
      };

    if (options.width) {
      style["width"] = `${options.width}px`;
      style["flex"] = `0 0 ${options.width}px`;
    }

    return style;
    // const { isShow, left, top } = this.props;

    // const { originWidth, originHeight, scale } = options;
    // return {
    //   visibility: isShow ? "visible" : "hidden",
    //   transform: `scale(${scale})`,
    //   transformOrigin: "0px 0px",
    //   width: `${originWidth}px`,
    //   height: `${originHeight}px`,
    // };
  };

  getInnerContainerStyles = (options) => {
    // const style = {};

    // if (options.height) {
    //   style["height"] = `${options.height}px`;
    // }

    // if (options.width) {
    //   style["width"] = `${options.width}px`;
    // }

    // return style;

    const { originWidth, originHeight, scale } = options;
    return {
      transform: `scale(${scale})`,
      transformOrigin: "0px 0px",
      width: `${originWidth}px`,
      height: `${originHeight}px`,
    };
  };

  render() {

    let {
        props,
        getInnerContainerStyles,
        maxWidth,
        groupHeight,
        getContainerStyle,
      } = this,
      {
        parseManage,
        backgroundImage,
        prospectImage,
        allMaterial,
        assetList,
        groupIndex,
        watermarkList,
      } = props,
      containerInfo = parseManage.getWidthScaleByGroup(groupHeight, groupIndex);

    if (containerInfo.width > maxWidth) {
      containerInfo = parseManage.getHeightScaleByGroup(maxWidth, groupIndex);
    }

    const containerStyles = getContainerStyle(containerInfo),
      innerContainerStyles = getInnerContainerStyles(containerInfo);

    return (
      <div className={`${styles.previewContainer}`} style={containerStyles}>
        <div
          className={`${styles.innerGroupContainer}`}
          style={innerContainerStyles}
        >
          <CommonPreview
            containerScale={containerInfo.scale}
            backgroundImage={backgroundImage}
            prospectImage={prospectImage}
            assetList={assetList}
            allMaterial={allMaterial}
            watermarkList={watermarkList}
          />
        </div>
      </div>
    );
  }
}

export default Preview;
