import React, { PureComponent } from "react";
import { connect } from "umi";
import styles from "./index.less";
// import throttle from "loadsh/throttle";
import { message } from "antd";
import PubSub from "pubsub-js";

class DragImageList extends PureComponent {
  constructor(props) {
    super(props);
    this.state = {};
    this.waterImage = "";
  }
  renderDragImageList = () => {
    const {
      dragImagePosition,
      currentSelectImageList,
      dragImageMoveing,
    } = this.props;
    if (!dragImageMoveing) return null;
    if (currentSelectImageList.length) {
      this.waterImage = currentSelectImageList[0].url;
    }
    const style = {
        transform: `translate(${dragImagePosition.left - 57}px,${
          dragImagePosition.top - 45
        }px)`,
      },
      imageList = currentSelectImageList.map((item, i) => {
        const key = item.id,
          src = item.imageSrc || item.url,
          style = {
            left: `${-i * 8}px`,
            top: `${i * 6}px`,
            zIndex: currentSelectImageList.length - i,
          };
        return (
          <div key={key} style={style} className={`${styles.dragImageItem}`}>
            <img src={src} alt="assetImage" />
          </div>
        );
      });

    return (
      <div style={style} className={`${styles.dragImageListContainer}`}>
        {imageList}
      </div>
    );
  };

  // handleDragImageContainerMove = throttle((e) => {
  //   const { clientX, clientY } = e,
  //     {
  //       dispatch,
  //       currentSelectImageList,
  //       dragImageMoveing,
  //       isShowDragImageContainer,
  //     } = this.props,
  //     payload = {
  //       dragImagePosition: {
  //         left: clientX,
  //         top: clientY,
  //       },
  //     };

  //   if (!isShowDragImageContainer) return;
  //   if (!dragImageMoveing) {
  //     payload.dragImageMoveing = true;
  //     if (currentSelectImageList.length > this.getCurrentGroupImageCount()) {
  //       dispatch({
  //         type: "workBench/save",
  //         payload: {
  //           currentSelectImageList: [],
  //         },
  //       });
  //       message.info("已选择足够多的素材");
  //       PubSub.publish("currentSelectImageChange");
  //       payload.dragImageMoveing = false;
  //       payload.isShowDragImageContainer = false;
  //     }
  //   }

  //   dispatch({
  //     type: "workBench/save",
  //     payload: payload,
  //   });
  // }, 16);

  handleDragImageContainerUp = () => {
    const { dispatch, dragImageMoveing } = this.props;
    if (!dragImageMoveing) return;
    dispatch({
      type: "workBench/save",
      payload: {
        dragImageMoveing: false,
        isShowDragImageContainer: false,
      },
    });
    //数组中有url字段表示是水印，否则是图库,是水印触发上传功能
    if (this.waterImage) {
      PubSub.publish("waterFullChange");
    }
  };

  getCurrentGroupImageCount = () => {
    const { parseManage, editCurrentGroupKey } = this.props;
    return parseManage.groups[editCurrentGroupKey].imageMaterial.length;
  };

  componentDidMount() {
    // window.addEventListener("mousemove", this.handleDragImageContainerMove);

    window.addEventListener("mouseup", this.handleDragImageContainerUp);
  }

  componentWillUnmount() {
    // window.removeEventListener("mousemove", this.handleDragImageContainerMove);
    window.removeEventListener("mouseup", this.handleDragImageContainerUp);
  }

  render() {
    const { renderDragImageList } = this;

    return <>{renderDragImageList()}</>;
  }
}

const stateToProps = (state) => {
  const { workBench } = state,
    {
      dragImageMoveing,
      dragImagePosition,
      currentSelectImageList,
      editCurrentGroupKey,
      parseManage,
      isShowDragImageContainer,
    } = workBench;

  return {
    dragImageMoveing: dragImageMoveing,
    isShowDragImageContainer: isShowDragImageContainer,
    dragImagePosition: dragImagePosition,
    currentSelectImageList: currentSelectImageList,
    parseManage: parseManage,
    editCurrentGroupKey: editCurrentGroupKey,
  };
};

export default connect(stateToProps)(DragImageList);
