import commonReducers from "utils/commonReducers";
import ParseConfig from "utils/lib/ParseConfig";
import { sourceRequest } from "utils/request";
import app from "@/utils/lib/app";
import Cookies from "js-cookie";

import { TOKEN_NAME, SOURCE_URL } from "@/types";


import {
  getTemplateInfo,
  submitRender,
  getVeLeapTemplateInfo,
  saveVeLeapEdit,
} from "services/root";
import { getEditContainerRectInfo, getGroups, json } from "utils/lib/getEditContainerRectInfo";
import { getIndexByAssetName } from "utils/lib/mapUtils";
import { getImageInfo, isVideo, wipeOffQueryString } from "utils";
import MatrixUtil from "utils/lib/MatrixUtil";
import env from "@/env";

const top = 59,
  bottom = 164,
  left = 99,
  right = 22,
  openAfterLeft = 399,
  openAfterRight = 236,
  customSpace = 60,
  editMainPdding = {
    verticalSpace: top + bottom,
    levelSpace: left + right,
    levelAfterSpace: openAfterLeft + openAfterRight,
    openAfterLeft: openAfterLeft,
    openAfterRight: openAfterRight,
    customSpace: customSpace,
  };

export default {
  namespace: "workBench",
  state: {
    editMainPdding: editMainPdding,
    editMainSizePercentage: 1,
    currentWatermarkKey: "",
    duration_sec: 0, //渲染时长，判断渲染速度快、慢或者正常
    isShowWatermarkTransform: false,
    watermarkList: [],
    aliPayinfo: {}, //支付时打开新页面
    isShowProgressModal: false, //控制完成并下载里面的modal
    progressList: [], //下载进度的列表
    origin_draft: {}, //用来存放原抠图的对象
    cut_origin_draft: {}, //裁切图片的原始数据
    batchClipImageGlobalVar: {}, // 批量裁剪信息
    checkAutoSize: true, //默认开启字体自适应
    editMainLoading: true, //进来默认加载，当接口请求完毕，或者上传成功的时候设置为false
    isShowPageLoading: false,
    mattingObj: {}, //匹配是否显示查看原图
    objpro: {}, //每个渲染进度
    objurl: {},
    objstatus: {},
    isShowButtonLoading: false,
    item_cover_image: "",
    pageLoadingTextInfo: "",
    weight_height_ratio: 1, //1: 9-16 2:3-4 3: 16-9 4: 1-1
    renderLogId: "",
    isShowPreviewOrDownloadModel: false,
    previewOrDownloadModelData: {},
    form: {},
    isOpenMaterialList: false,
    isOpenEditWindow: false,
    testData: false,
    groupHeight: 128,
    backgroundImageList: {},
    prospectImageList: {},
    allMaterialByGroup: {},
    allOriginMaterialByGroup: {},
    assetList: {}, //页面渲染时模板图片的信息，初始状态下它==originAssetList ，模板数据同理
    productName: "",
    currentSelectImageList: [],
    isShowDragImageContainer: false,
    dragImageMoveing: false,
    dragImagePosition: {
      left: 0,
      top: 0,
    },
    //截取视频图片从截取位置展示
    editVideoTime: {
      editVideoStartTime: 0,
      editVideoStartEndtime: 0,
    },
    isFullEditMain: false,
    cropPicture: "", //图片裁切页面显示的待裁切的图片
    originAssetList: {}, //模板初始数据中所有的图片
    editCurrentGroupKey: "",
    editWindowCurrentIndex: 1,
    isShowTransform: false,
    isTransforming: false,
    currentMaterialKey: "",
    parseManage: {},
    isShowMaterialMaskCanvas: false,
    isShowVideoPreview: false,
    videoPreviewUrl: "",
    editFirstLoadContainerInfo: {
      scale: 1,
      width: 0,
      height: 0,
    },
    editMainContainerInfo: {
      scale: 1,
      width: 0,
      height: 0,
    },
    equalList: [], //文字内容相同的assname
  },
  subscriptions: {
    setup({ dispatch, history }) {},
  },
  effects: {
    *getConfigJson({ payload }, { put }) {
      const {
          configUrl,
          bgList,
          assetList,
          fgList,
          productName,
          draftData,
          cut_origin_draft,
          duration_sec,
          callback,
        } = payload,
        { success, data } = yield sourceRequest(configUrl);
      if (!success) return;
      let parseManage = new ParseConfig(data),
        { allMaterialByGroup, allOriginMaterialByGroup, firstGroupKey } = getGroups(
          json(parseManage["groups"]),
        ),
        editContainerInfo = getEditContainerRectInfo(
          parseManage,
          firstGroupKey,
          editMainPdding.levelSpace + editMainPdding.customSpace + 300,
          editMainPdding.verticalSpace + editMainPdding.customSpace, //最开始加了五十，不知道有什么用，但是会导致初始化时模板的高度和其他不一样,所以删除
        ),
        bg_list = JSON.parse(bgList),
        asset_list = JSON.parse(assetList),
        fg_list = JSON.parse(fgList),
        edit_asset_list = JSON.parse(assetList),
        watermarkList = [];
        //桌面测试detail文件中没有渲染视频的时长，需要从json中取
        let demoLeapTime = parseManage.configJson.duration/parseManage.configJson.fps
      var sourceHost = env.sourceHost;
      for (var key in edit_asset_list) {
        if (edit_asset_list.hasOwnProperty(key)) {
          if (edit_asset_list[key].indexOf("//") === -1) {
            edit_asset_list[key] = sourceHost + edit_asset_list[key];
          } else {
            edit_asset_list[key] += "?cache=1024";
          }

          let fileFormat = key.substring(key.lastIndexOf(".") + 1).toUpperCase();
          if (fileFormat === "MP4" || fileFormat === "MOV") {
            if (edit_asset_list[key].indexOf("static.atvideo.cc") !== -1) {
              if(edit_asset_list[key].indexOf("?cache=1024") !== -1){
                edit_asset_list[key] += "&vframe/png/offset/0";
              }else{
                edit_asset_list[key] += "?vframe/png/offset/0";
              }
            } else {
              if(edit_asset_list[key].indexOf("?cache=1024") !== -1){
                edit_asset_list[key] += "&x-oss-process=video/snapshot,t_0";
              }else{
                edit_asset_list[key] += "?x-oss-process=video/snapshot,t_0";
              }
            }
          }
        }
      }

      if (draftData) {
        if (draftData["editAfterImageList"]) {
          yield put({
            type: "batchReplacement",
            payload: {
              groups: parseManage.groups,
              assetList: edit_asset_list,
              originAssetList: edit_asset_list,
              allMaterialByGroup: allMaterialByGroup,

              currentSelectImageList: draftData["editAfterImageList"],
              allOriginMaterialByGroup: allOriginMaterialByGroup,
            },
          });
        }

        if (draftData["assetList"]) {
          edit_asset_list = {
            ...asset_list,
            ...draftData["assetList"],
          };
        }

        if (draftData["allMaterialByGroup"]) {
          allMaterialByGroup = {
            ...allMaterialByGroup,
            ...draftData["allMaterialByGroup"],
          };
        }

        if (draftData["watermarkList"]) {
          watermarkList = [...draftData["watermarkList"]];
        }
      }

      // console.log("init config.json -->", allMaterialByGroup);

      // 自适应
      for (let groupKey in allMaterialByGroup) {
        allMaterialByGroup[groupKey].forEach(function(e) {
          // e.needAutoAdapt = true;

          if (e.type !== 1) {
            return;
          }

          let adapt = MatrixUtil.autoAdapt(e.originSize, e.asset.ui.editSize);
          e.position = adapt.position;
          e.anchor = adapt.anchor;
          e.scale = adapt.scale;
          e.rotate = adapt.rotate;
        });
      }
      var cutOriginDraft =
        cut_origin_draft === "{}" || !cut_origin_draft || cut_origin_draft === "null"
          ? edit_asset_list
          : JSON.parse(cut_origin_draft);

      // 是否获取临时会话 token
      if (env.enableSessionToken || window.location.search.indexOf('pid') !== -1) {
        app.request('/demo/public/gen_token', {}).then(res => {
          Cookies.set(TOKEN_NAME, res.data["token"]);
          Cookies.set(SOURCE_URL, res.data["source_url"]);
        })
      }    

      // console.log("init config.json ++>", allMaterialByGroup);
      yield put({
        type: "save",
        payload: {
          editMainContainerInfo: editContainerInfo,
          parseManage: parseManage,
          cut_origin_draft: cutOriginDraft,
          allMaterialByGroup: allMaterialByGroup,
          allOriginMaterialByGroup: allOriginMaterialByGroup,
          editCurrentGroupKey: firstGroupKey,
          backgroundImageList: bg_list,
          prospectImageList: fg_list,
          assetList: edit_asset_list,
          // originAssetList: json(asset_list),
          originAssetList: { ...edit_asset_list },
          isShowTransform: false,
          duration_sec:duration_sec?duration_sec:demoLeapTime,
          currentMaterialKey: "",
          isOpenEditWindow: true,
          isOpenMaterialList: true,
          isTransforming: false,
          editWindowCurrentIndex: 1,
          currentSelectImageList: [],
          dragImageMoveing: false,
          isShowDragImageContainer: false,
          isShowMaterialMaskCanvas: false,
          isShowPreviewOrDownloadModel: false,
          editFirstLoadContainerInfo: editContainerInfo,
          productName: productName,
          isShowPageLoading: false,
          pageLoadingTextInfo: "",
          editMainSizePercentage: 1,
          isShowVideoPreview: false,
          videoPreviewUrl: "",
          selectMaterialType: 3, //工作区域左侧侧边栏，默认选中图库，1的话是模板
          isFullEditMain: false,
          dragImagePosition: {
            left: 0,
            top: 0,
          },
          equalList: [],
          currentWatermarkKey: "",
          isShowWatermarkTransform: false,
          watermarkList: watermarkList,
        },
      });

      callback && callback();
    },
    //重置位置
    *initAddress({ payload }, { put }) {
      const { allMaterialByGroup, currentMaterialKey } = payload;
      let newAllMaterialByGroup = { ...allMaterialByGroup };
      let e = app.getMaterial(allMaterialByGroup, currentMaterialKey);
      if (e.type === 1) {
        let adapt = MatrixUtil.autoAdapt(e.originSize, e.asset.ui.editSize);
        e.position = adapt.position;
        e.anchor = adapt.anchor;
        e.scale = adapt.scale;
        e.rotate = adapt.rotate;
      }
      yield put({
        type: "save",
        payload: {
          allMaterialByGroup: newAllMaterialByGroup,
        },
      });
    },
    *replaceMultipleImage({ payload }, { put }) {
      let {
          assetList,
          allMaterialByGroup,
          editCurrentGroupKey,
          currentSelectImageList,
          allOriginMaterialByGroup,
          origin_draft,
          cut_origin_draft,
        } = payload,
        newAssetList = {
          ...assetList,
        },
        newAllMaterialByGroup = {
          ...allMaterialByGroup,
        },
        currentAllMaterialList = allMaterialByGroup[editCurrentGroupKey];
      let newCurrentAllMaterialList = currentAllMaterialList
          .filter(listItem => listItem.type === 1)
          .sort((a, b) => b.zIndex - a.zIndex),
        promiseList = newCurrentAllMaterialList.map(async (materialItem, i) => {
          if (!currentSelectImageList[i]) return;
          const { assetName } = materialItem,
            index = getIndexByAssetName(assetName, currentAllMaterialList),
            { imageSrc } = currentSelectImageList[i];
          console.log(imageSrc,'ssssss')
          let  isVideoFile = isVideo(wipeOffQueryString(imageSrc));
          let newFileUrl = wipeOffQueryString(imageSrc);
          if (isVideoFile) {
            newFileUrl += "?x-oss-process=video/snapshot,t_0";
          }
          let { width, height } = await getImageInfo(newFileUrl),
            originAssetWidth = allOriginMaterialByGroup[editCurrentGroupKey][index].originSize[0],
            fitWidthScale = originAssetWidth / width;
          if (originAssetWidth > width) {
            fitWidthScale = width / originAssetWidth;
          }
          newAssetList[assetName] = newFileUrl;
          newAllMaterialByGroup[editCurrentGroupKey][index].isVideo = isVideoFile;
          newAllMaterialByGroup[editCurrentGroupKey][index].originSize = [width, height];
          newAllMaterialByGroup[editCurrentGroupKey][index].anchor = [width / 2, height / 2];
          newAllMaterialByGroup[editCurrentGroupKey][index].scale = [fitWidthScale, fitWidthScale];
          newAllMaterialByGroup[editCurrentGroupKey][index].distScale = [
            fitWidthScale,
            fitWidthScale,
          ];
          if (!origin_draft) origin_draft = {};
          if (!cut_origin_draft) cut_origin_draft = {};

          origin_draft[assetName] = newFileUrl;
          cut_origin_draft[assetName] = newFileUrl;
        });
      yield Promise.all(promiseList);

      yield put({
        type: "save",
        payload: {
          allMaterialByGroup: newAllMaterialByGroup,
          assetList: newAssetList,
          origin_draft,
          cut_origin_draft,
        },
      });
    },

    *clearReplacement({ payload }, { put }) {
      const { assetList, allMaterialByGroup, newImageList, allOriginMaterialByGroup } = payload,
        promiseList = [],
        newAssetList = {
          ...assetList,
        },
        newAllMaterialByGroup = {
          ...allMaterialByGroup,
        };
      const pList = newImageList.map(async materialItem => {
        const { assetName, groupKey, url } = materialItem,
          index = getIndexByAssetName(assetName, newAllMaterialByGroup[groupKey]),
          isVideoFile = isVideo(wipeOffQueryString(url));

        let newFileUrl = wipeOffQueryString(url);
        if (isVideoFile) {
          newFileUrl += "?x-oss-process=video/snapshot,t_0";
        }
        let { width, height } = await getImageInfo(newFileUrl);
        newAssetList[assetName] = newFileUrl;
        newAllMaterialByGroup[groupKey][index].isVideo = isVideoFile;
        newAllMaterialByGroup[groupKey][index].originSize =
          allOriginMaterialByGroup[groupKey][index].originSize;
        // newAllMaterialByGroup[groupKey][index].anchor =
        //   allOriginMaterialByGroup[groupKey][index].anchor;
        // newAllMaterialByGroup[groupKey][index].scale =
        //   allOriginMaterialByGroup[groupKey][index].scale;
        // newAllMaterialByGroup[groupKey][index].position =
        //   allOriginMaterialByGroup[groupKey][index].position;
        // newAllMaterialByGroup[groupKey][index].rotate =
        //   allOriginMaterialByGroup[groupKey][index].rotate;

        let e = newAllMaterialByGroup[groupKey][index];
        if (e.type == 1) {
          let adapt = MatrixUtil.autoAdapt(e.originSize, e.asset.ui.editSize);
          e.position = adapt.position;
          e.anchor = adapt.anchor;
          e.scale = adapt.scale;
          e.rotate = adapt.rotate;
        }
      });

      promiseList.push(...pList);

      yield Promise.all(promiseList);
      yield put({
        type: "save",
        payload: {
          allMaterialByGroup: newAllMaterialByGroup,
          assetList: newAssetList,
        },
      });
    },
    *batchReplacement({ payload }, { put }) {
      const {
          assetList,
          allMaterialByGroup,
          currentSelectImageList,
          groups,
          originAssetList,
          allOriginMaterialByGroup,
        } = payload,
        newAssetList = {
          ...assetList,
        },
        newAllMaterialByGroup = {
          ...allMaterialByGroup,
        };

      let count = 0,
        promiseList = [],
        newGroupList = [],
        currentSelectImageListLength = currentSelectImageList.length,
        groupKeyList = Object.keys(groups);

      for (let j = 0; j < groupKeyList.length; j++) {
        const groupKey = groupKeyList[j];
        let sortAfterList = newAllMaterialByGroup[groupKey]
          .filter(listItem => listItem.type === 1)
          .sort((a, b) => b.zIndex - a.zIndex);
        let canReplaceCount = sortAfterList.length;
        let replaceImageList = [];
        let replaceImageCount = 0;
        sortAfterList.map(({ assetName }) => {
          if (originAssetList[assetName] !== assetList[assetName]) {
            canReplaceCount--;
          }
        });
        for (let i = 0; i < canReplaceCount; i++) {
          if (count >= currentSelectImageListLength) break;
          replaceImageList.push({
            imageSrc: currentSelectImageList[count],
          });
          count++;
        }

        if (replaceImageList.length !== 0) {
          sortAfterList.map(({ assetName }) => {
            if (originAssetList[assetName] === assetList[assetName]) {
              const currentUrl = replaceImageList[replaceImageCount];
              if (currentUrl) {
                newGroupList.push({
                  groupKey: groupKey,
                  replaceUrl: currentUrl.imageSrc,
                  assetName: assetName,
                });
              }
              replaceImageCount++;
            }
          });
        }
      }

      let pList = newGroupList.map(async ({ assetName, replaceUrl, groupKey }) => {
        const index = getIndexByAssetName(assetName, newAllMaterialByGroup[groupKey]),
          isVideoFile = isVideo(wipeOffQueryString(replaceUrl));
        let newFileUrl = wipeOffQueryString(replaceUrl);
        if (isVideoFile) {
          newFileUrl += "?x-oss-process=video/snapshot,t_0";
        }
        let { width, height } = await getImageInfo(newFileUrl),
          originAssetWidth = allOriginMaterialByGroup[groupKey][index].originSize[0],
          fitWidthScale = originAssetWidth / width;
        if (originAssetWidth > width) {
          fitWidthScale = width / originAssetWidth;
        }

        newAssetList[assetName] = newFileUrl;
        newAllMaterialByGroup[groupKey][index].isVideo = isVideoFile;
        newAllMaterialByGroup[groupKey][index].originSize = [width, height];

        // 自动适配
        console.log("----", newAllMaterialByGroup[groupKey][index]);

        let e = newAllMaterialByGroup[groupKey][index];
        if (e.type == 1) {
          let adapt = MatrixUtil.autoAdapt(e.originSize, e.asset.ui.editSize);
          e.position = adapt.position;
          e.anchor = adapt.anchor;
          e.scale = adapt.scale;
          e.rotate = adapt.rotate;
        }

        return 1;
      });

      promiseList.push(...pList);
      yield Promise.all(promiseList);
      //如果是一键替换照片，需要保存原图。取巧原图包含asset/assetxx.png ,新图则是长字符
      let beforeImageObj = {};
      for (var i in newAssetList) {
        if (newAssetList[i].indexOf("asset/asset") == -1) {
          beforeImageObj[i] = newAssetList[i];
        }
      }
      yield put({
        type: "save",
        payload: {
          allMaterialByGroup: newAllMaterialByGroup,
          assetList: newAssetList,
          cut_origin_draft: JSON.stringify(beforeImageObj) === "{}" ? newAssetList : beforeImageObj,
          origin_draft: beforeImageObj,
        },
      });
    },
    *replaceImage({ payload }, { put }) {
      const {
          assetList,
          assetName,
          allMaterialByGroup,
          editCurrentGroupKey,
          dataItem,
          allOriginMaterialByGroup,
          recordTime = 0,
          origin_draft,
          cut_origin_draft,
        } = payload,
        newUrl = dataItem.imageSrc,
        newAssetList = {
          ...assetList,
        },
        newAllMaterialByGroup = {
          ...allMaterialByGroup,
        },
        currentAllMaterialList = allMaterialByGroup[editCurrentGroupKey],
        index = getIndexByAssetName(assetName, currentAllMaterialList),
        distPosition = newAllMaterialByGroup[editCurrentGroupKey][index].distPosition;

      let isVideoFile = newUrl ? isVideo(wipeOffQueryString(newUrl)) : "";
      let newFileUrl = newUrl ? wipeOffQueryString(newUrl) : "";
      //替换图片的时候改变原来抠图的数据
      yield put({
        type: "save",
        payload: {
          origin_draft: origin_draft,
        },
      });
      //如果是上传图片的时候才保存
      if (cut_origin_draft) {
        yield put({
          type: "save",
          payload: {
            cut_origin_draft: cut_origin_draft,
          },
        });
      }
      if (isVideoFile) {
        if (newFileUrl.indexOf("static.atvideo.cc") !== -1) {
          newFileUrl += "?vframe/png/offset/0";
        } else {
          newFileUrl += "?x-oss-process=video/snapshot,t_" + recordTime;
        }
      }

      let { width, height } = yield getImageInfo(newFileUrl);

      // console.log("--- replace image", width, height, newFileUrl);
      newAssetList[assetName] = newFileUrl;

      let e = newAllMaterialByGroup[editCurrentGroupKey][index];
      newAllMaterialByGroup[editCurrentGroupKey][index].originSize = [width, height];
      // 自动适配
      if (e.type == 1) {
        let adapt = MatrixUtil.autoAdapt(e.originSize, e.asset.ui.editSize);
        e.position = adapt.position;
        e.anchor = adapt.anchor;
        e.scale = adapt.scale;
        e.rotate = adapt.rotate;
      }

      newAllMaterialByGroup[editCurrentGroupKey][index].isVideo = isVideoFile;
      yield put({
        type: "save",
        payload: {
          allMaterialByGroup: newAllMaterialByGroup,
          assetList: newAssetList,
          editMainLoading: false,
        },
      });
    },
    *saveProductName({ payload }, { call, put }) {
      const { productName, productId } = payload;

      yield put({
        type: "save",
        payload: {
          productName: productName,
        },
      });
      yield call(submitRender, {
        art_name: productName,
        product_id: productId,
      });
    },
    *saveProductEditJson({ payload }, { call, put }) {
      //如果没有上传照片，origin_draft 取asslist,当上传图片后则重新赋值

      const { origin_draft, cut_origin_draft, ...others } = payload.data,
        dataJsonString = JSON.stringify(others),
        requestData = {
          product_id: payload.productId,
          draft: dataJsonString,
          origin_draft: JSON.stringify(origin_draft),
          cut_origin_draft: JSON.stringify(cut_origin_draft),
        };
      //随意替换了函数名

      const { success } = yield call(submitRender, requestData);
      if (success) {
        payload.callback && payload.callback();
      }
    },
  },
  reducers: {
    ...commonReducers,
    //相同的文字需要同时替换
    changeEqualText(state, { payload }) {
      const { allMaterialByGroup, editCurrentGroupKey } = state,
        { data } = payload,
        { size, equlist, text } = data;
      const currentMaterialList = allMaterialByGroup[editCurrentGroupKey];
      currentMaterialList.forEach(v => {
        equlist.forEach(m => {
          if (v.assetName === m) {
            v.fontSetting.defaultText = text;
            v.fontSetting.fontSize = size;
          }
        });
      });
      return {
        ...state,
        allMaterialByGroup: allMaterialByGroup,
        isShowMaterialMaskCanvas: false,
      };
    },
    changeGroupData(state, { payload }) {
      const { allMaterialByGroup, editCurrentGroupKey, currentMaterialKey } = state,
        newAllMaterialByGroup = {
          ...allMaterialByGroup,
        },
        currentMaterialList = [...newAllMaterialByGroup[editCurrentGroupKey]],
        currentMaterialIndex = getIndexByAssetName(currentMaterialKey, currentMaterialList),
        currentMaterial = currentMaterialList[currentMaterialIndex],
        { type, data } = payload;

      if (
        type === "changeText" ||
        (currentMaterial["fontSetting"] &&
          type !== "changeTextColor" &&
          type !== "changeStrokeColor" &&
          type !== "changeStrokeWidth")
      ) {
        if (currentMaterial["fontSetting"] && currentMaterial["fontSetting"]["defaultText"]) {
          currentMaterial["fontSetting"]["defaultText"] = data.text;
        }
      }

      // 设置素材的矩阵信息是否已经初始化，比如第一次需要进行居中处理
      if (type === "setNeedAutoAdapt") {
        currentMaterial["needAutoAdapt"] = data;
      }

      if (type === "scale") {
        let newScaleX = currentMaterial.scale[0] * data["offsetScaleX"],
          newScaleY = currentMaterial.scale[1] * data["offsetScaleY"];
        currentMaterial.scale = [newScaleX, newScaleY];

        if (!currentMaterial["distScale"]) {
          currentMaterial["distScale"] = [1, 1];
        }

        let newDistScaleX = currentMaterial["distScale"][0] * data["offsetScaleX"],
          newDistScaleY = currentMaterial["distScale"][1] * data["offsetScaleY"];
        currentMaterial["distScale"] = [newDistScaleX, newDistScaleY];
      }

      if (type === "setScale") {
        currentMaterial.scale = data;
      }

      if (type === "setPosition") {
        currentMaterial["position"] = [data[0], data[1]];
      }

      if (type === "setRotate") {
        currentMaterial.rotate = data.rotate;
        if (!currentMaterial["rotate"]) {
          currentMaterial["rotate"] = 0;
        }
        currentMaterial["rotate"] = data;
      }

      if (type === "rotate") {
        currentMaterial.rotate = currentMaterial.rotate + data.rotate;
        if (!currentMaterial["distRotate"]) {
          currentMaterial["distRotate"] = 0;
        }
        currentMaterial["distRotate"] += data.rotate;
      }

      if (type === "position") {
        let newX = currentMaterial.position[0] + data.offsetX,
          newY = currentMaterial.position[1] + data.offsetY;
        currentMaterial.position = [newX, newY];

        if (!currentMaterial["distPosition"]) {
          currentMaterial["distPosition"] = [0, 0];
        }
        currentMaterial["distPosition"] = [
          currentMaterial["distPosition"][0] + data.offsetX,
          currentMaterial["distPosition"][1] + data.offsetY,
        ];
      }
      if (type === "dragPosition") {
        currentMaterial["distPosition"] = [data.offsetX, data.offsetY];
      }

      if (type === "reset") {
        currentMaterial.rotate = data.rotate;
        currentMaterial.scale = [...data.scale];
        currentMaterial.position = [...data.position];
        if (currentMaterial["distRotate"]) {
          currentMaterial["distRotate"] = 0;
        }

        if (currentMaterial["distRotate"]) {
          currentMaterial["distRotate"] = 0;
        }

        if (currentMaterial["distScale"]) {
          currentMaterial["distScale"] = [1, 1];
        }

        if (currentMaterial["distPosition"]) {
          currentMaterial["distPosition"] = [0, 0];
        }
      }

      if (type === "changeText") {
        if (currentMaterial["fontSetting"]) {
          currentMaterial["fontSetting"]["defaultText"] = data.text;
        }
      }
      //当改变文本内容时，顺便赋值自适应的文字尺寸

      if (type === "changeFontSize" || (type === "changeText" && data.size)) {
        if (currentMaterial["fontSetting"]) {
          currentMaterial["fontSetting"]["fontSize"] = data.size;
        }
      }

      if (type === "changeTextColor") {
        currentMaterial["fontSetting"]["textColor"] = data.color;
      }

      if (type === "changeStrokeColor") {
        currentMaterial["fontSetting"]["strokeColor"] = data.color;
      }

      if (type === "changeStrokeWidth") {
        currentMaterial["fontSetting"]["strokeWidth"] = data.width;
      }

      if (type === "videoClip") {
        currentMaterial["videoClip"] = data;
      }

      if (type === "changeVolume") {
        currentMaterial["volume"] = data.volume;
      }

      if (type === "resetAllFontSetting") {
        currentMaterial["fontSetting"] = data.fontSetting;
      }
      currentMaterialList[currentMaterialIndex] = currentMaterial;
      newAllMaterialByGroup[editCurrentGroupKey] = currentMaterialList;
      return {
        ...state,
        allMaterialByGroup: newAllMaterialByGroup,
        // isShowMaterialMaskCanvas: false,
      };
    },

    changeWatermarkData(state, { payload }) {
      const newWatermarkList = [...state.watermarkList],
        { data, currentIndex, type } = payload,
        currentWatermark = {
          ...newWatermarkList[currentIndex],
        };

      if (type === "setPosition") {
        currentWatermark["position"] = data.position;
        currentWatermark["positionIndex"] = data.activeIndex;
      }

      if (type === "setScale") {
        currentWatermark["scale"] = data.scale;
      }

      if (type === "resetAll") {
        currentWatermark["scale"] = data.scale;
        currentWatermark["position"] = data.position;
        currentWatermark["positionIndex"] = data.activeIndex;
      }

      newWatermarkList[currentIndex] = currentWatermark;
      return {
        ...state,
        watermarkList: newWatermarkList,
      };
    },
  },
};
