import React, { PureComponent } from "react";
import { Button, Spin } from "antd";
import { connect } from "dva";
import styles from "./index.less";
import MaterialLibrary from "components/MaterialLibrary";
import EditGroups from "components/EditGroups";
import EditWindow from "components/EditWindow";
import RenderButtonComponent from 'components/RenderButtonComponent'
import EditMain from "components/EditMain";
import Tailoring from "components/Tailoring/standby";
import MaterialLibraryModel from "components/MaterialLibraryModel";
import VideoClip from "components/VideoClip";
import SaveDrafts from "components/SaveDrafts";
import { history } from 'umi';
import app from '@/utils/lib/app'



import { getTemplateInfo,getVeLeapTemplateInfo } from "services/root";
class Editor extends PureComponent {

  getCurrentGroupAccessoryImage() {

    const {
      parseManage, currentGroup, backgroundImageList, prospectImageList,
    } = this.props["editor"];

    let backgroundImage = "",
      prospectImage = "",
      groupKey = "";
    for (const key in currentGroup) {
      if (currentGroup.hasOwnProperty(key)) {
        backgroundImage = parseManage.groups[key].backgroundImage;
        prospectImage = parseManage.groups[key].prospectImage;
        groupKey = key;
      }
    }

    return {
      backgroundImage: backgroundImageList[backgroundImage],
      prospectImage: prospectImageList[prospectImage],
      groupKey: groupKey,
    };

  }

  renderLoading(status, text) {
    if (!status) return null;
    return (
      <div className={`flex ${styles.loadingEditorContainer}`}>
        <Spin size="large" tip={`${text}...`}/>
      </div>
    );
  }

  renderCropBox() {
    const { isShowCorpImage } = this.props["editor"];
    if (!isShowCorpImage) return null;
    return (
      <Tailoring/>
    );
  }

  renderVideoClipBox() {
    const { isShowVideoClip } = this.props["editor"];
    if (!isShowVideoClip) return null;
    return (
      <VideoClip/>
    );
  }

  renderSaveDrafts() {
    const { isVeLeapTest } = this.props["editor"];
    if (!isVeLeapTest) return null;

    return (
      <SaveDrafts/>
    );
  }
  //提交渲染
  submitOrder=()=>{
    console.log('fuck')
  };
  dispatchMiddle = (type, payload) => {
    const { dispatch } = this.props;
    dispatch({
      type: `editor/${type}`,
      payload: payload,
    });
  };
  
  getEditData = async () => {
    //桌面测试入口 test_id

    const { location, dispatch } = this.props;
    var  query = location.query;
    let obj,template;

    // if(app.getUrlValue('test_id')){
    //   obj =  await getVeLeapTemplateInfo({act:'detail',test_id:app.getUrlValue('test_id')})
    // }
    // console.log(app.getUrlValue('test_id'))
    //证明是模板交付系统过来的
      if(query.pid || query.test_id){
        //我是设计师
        let data =  {
          access_token:query.a,
          token:query.v,
          id:query.pid
        }
        //桌面测试
        if(query.test_id){
          data.id = ''
          data.test_id = query.test_id
        }
        obj =  await getVeLeapTemplateInfo(data)
        template = obj.data.tpl
      
      }else{
        //常规模板
        obj =  await getTemplateInfo({act:'detail', id:query.templateId })
        template = obj.data.detail
        if(!obj.success) return
      }
        dispatch({
          type:'editor/save',
          payload:{
            currentTemplateInfo:template,
          isVeLeapTest:query.pid?true:false
  
          }
      })

 
    //将宽高比存起来，预览视频的时候使用
    // dispatch({
    //   type: "workBench/save",
    //   payload: {
    //     weight_height_ratio: data.product.weight_height_ratio,
    //     origin_draft:
    //       origin_draft !== "{}" && origin_draft && origin_draft !== "null"
    //         ? JSON.parse(origin_draft)
    //         : {},
    //     // cut_origin_draft:
    //     // cut_origin_draft&& cut_origin_draft !== "{}" && cut_origin_draft !=='null'
    //     //     ? JSON.parse(cut_origin_draft)
    //     //     : template["asset_list"],
    //     mattingObj: {},
    //     item_cover_image: cover_image,
    //   },
    // });
    return {
      configUrl: template["config_url"],
      assetList: template["asset_list"],
      bgList: template["bg_list"],
      fgList: template["fg_list"],
      duration_sec:template['duration_sec'],
      // cut_origin_draft: data.product["cut_origin_draft"],
      // origin_draft: data.product["origin_draft"],
      productName: template["template_name"],
      // draftData: JSON.parse(draft),
    };
  };
  componentDidMount() {
    const { dispatch } = this.props;


    this.getEditData().then((res) => {
      if (!res) return;

      dispatch({
        type: "workBench/getConfigJson",
        payload: res,
      });
    });
    // window.addEventListener('beforeunload', this.beforeunload);
  }
  render() {
    const {
        horizontalVersion, showStyleInfo, scale, isOpenMaterialList,
        editorContainerHeight, totalTime, backgroundImageList, prospectImageList,
        assetList, allMaterialByGroup, parseManage, pageLoading, pageLoadingText,
      } = this.props["editor"],
      accessoryImage = this.getCurrentGroupAccessoryImage();

    return (
      <div className={`borderBox ${styles.editorContainer}`}>
        {this.renderLoading(pageLoading, pageLoadingText)}
        {this.renderCropBox()}
        {this.renderVideoClipBox()}
        {this.renderSaveDrafts()}
        <MaterialLibraryModel/>
        <MaterialLibrary/>
        <EditGroups
          groups={allMaterialByGroup}
          horizontalVersion={horizontalVersion}
          containerHeight={showStyleInfo.groupHeight}
          isOpenMaterialList={isOpenMaterialList}
          editorContainerHeight={editorContainerHeight}
          totalTime={totalTime}
          backgroundImageList={backgroundImageList}
          prospectImageList={prospectImageList}
          assetList={assetList}
          allMaterialByGroup={allMaterialByGroup}
          parseManage={parseManage}
          currentGroupKey={accessoryImage.groupKey}
        />
        <EditWindow/>
        <EditMain
          isHorizontalVersion={horizontalVersion}
          containerHeight={showStyleInfo.containerHeight}
          scale={scale.container}
          backgroundImage={accessoryImage.backgroundImage}
          prospectImage={accessoryImage.prospectImage}
        />
        <RenderButtonComponent/>
      </div>
    );
  }

}


const stateToProps = (state) => {
  let loading = state["loading"]["global"];
  return {
    loadingEffects: loading,
    editor: state["editor"],
    query: state["router"]["location"]["query"],
  };
};

export default connect(stateToProps)(Editor);
