import axios from "axios";
import env from '@/env'
import Cookies from "js-cookie";
import { TOKEN_NAME, SOURCE_URL } from "@/types";
const app = {
  //通过canvas 计算文字的真实宽度
  getTextWith(text, fontStyle) {
    var canvas = document.createElement("canvas");
    var context = canvas.getContext("2d");
    context.font = fontStyle || "16px"; // 设置字体样式，当然，也可以在这里给一个默认值
    var dimension = context.measureText(text);
    return dimension.width;
  },
  //尺寸自适应，传入当前文本对象的数据
  getAutoSize(obj, value) {
    const { originSize } = obj;
    // let width = 0,
    //   height = 0;
    // if (originSize[0] > originSize[1]) {
    //   width = originSize[0];
    //   height = originSize[1];

    // } else {
    //   width = originSize[1];
    //   height = originSize[0];
    // }
    let width = Math.max(...originSize);
    let height = Math.min(...originSize);
    if (!value) {
      return;
    }
    //判断是否为中文
    let re = /^[\u4E00-\u9FA5]+$/;
    let wordCount = 0;
    for (var i in value) {
      if (re.test(value[i])) {
        wordCount += 1;
      } else {
        wordCount += 0.5;
      }
    }
    // let fontStyle = `${obj.fontSetting.fontSize} ${obj.fontSetting.fontFamily}`
    // let fontWidth = app.getTextWith(value,fontStyle)
    let checkAutoSize = sessionStorage.getItem("checkAutoSize");
    let row = height / obj.asset.ui.size <= 1 ? 1 : height / obj.asset.ui.size;
    let len = Math.ceil(wordCount / row);

    let size = width / len > 11 ? width / len : 11; //浏览器最小识别字体大小11px
    let beforeSize = obj.asset.ui.size;

    if (size >= beforeSize) {
      size = beforeSize;
    }
    if (width === 0 || checkAutoSize === "closeAutosize") {
      return beforeSize;
    } else {
      return parseInt(size);
    }
  },
  //当前的对象数据
  getMaterial(group, Name) {
    var obj = {};
    for (var i in group) {
      group[i].forEach(item => {
        if (item.assetName === Name) {
          obj = item;
        }
      });
     
    }
    return obj;
  },
  //是否支持webGl
  Detector: {
    canvas: !!window.CanvasRenderingContext2D,
    webgl: (function() {
      try {
        var canvas = document.createElement("canvas");
        return !!(
          window.WebGLRenderingContext &&
          (canvas.getContext("webgl") || canvas.getContext("experimental-webgl"))
        );
      } catch (e) {
        return false;
      }
    })(),
  },
  //获取url参数
  getUrlValue: function(name) {
    var after = window.location.href.split("?")[1];
    if (after) {
      var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
      var r = after.match(reg);
      if (r != null) {
        return decodeURIComponent(r[2]);
      } else {
        return null;
      }
    }
  },
  //是否是veleap跳过来的
  isLeap() {
    if (app.getUrlValue("pid")) {
      return true;
    } else {
      return false;
    }
  },
  request: (url, data, type = "post", token) => {
    const APIURL =env.renderHost;
    var promise = new Promise((resolve, reject) => {
      let obj = {
        method: type,
        url: url.indexOf("phpsdk") !== -1 || url.indexOf('veleap') !== -1 ? url : APIURL + url,
        headers: {
          "login-token": Cookies.get(TOKEN_NAME),
          "Content-Type": "application/json;charset=UTF-8",
        },
      };

      if (type === "get") {
        obj.params = data;
      } else {
        obj.data = data;
      }
      axios(obj)
        .then(function(response) {
          resolve(response.data);
        })
        .catch(function(error) {
          console.log(error);
        });
    });
    return promise;
  },
};
export default app;
