export function getEditContainerRectInfo(
  parseManage,
  groupIndex,
  levelSpace = 0,
  verticalSpace = 0,
) {
  const windowHeight = window.innerHeight,
    windowWidth = window.innerWidth,
    expectHeight = windowHeight - verticalSpace,
    expectWidth = windowWidth - levelSpace;
  let containerInfo = parseManage.getWidthScaleByGroup(
      expectHeight,
      groupIndex,
    ),
    result = {
      ...containerInfo,
      height: expectHeight,
    };

  if (expectWidth <= containerInfo.width) {
    let maxHeightInfo = parseManage.getHeightScaleByGroup(
      expectWidth,
      groupIndex,
    );
    containerInfo = parseManage.getWidthScaleByGroup(
      maxHeightInfo.height,
      groupIndex,
    );
    result = {
      ...containerInfo,
      height: maxHeightInfo.height,
    };
  }
  result.width = parseManage.templateWidth
  result.height = parseManage.templateHeight



  return result;
}

export function json(o) {
  return JSON.parse(JSON.stringify(o));
}

export function getGroups(groups, editAfterData) {
  const allMaterialByGroup = {},
    allOriginMaterialByGroup = {};

  let key = "",
    firstGroupKey = "";

  for (key in groups) {
    if (groups.hasOwnProperty(key)) {
      const group = groups[key];
      if (editAfterData) {
        allMaterialByGroup[key] = json(
          editAfterData["allMaterialByGroup"][key],
        );
      } else {
        allMaterialByGroup[key] = json(group["allMaterial"]);
      }
      allOriginMaterialByGroup[key] = json(group["allMaterial"]);
      if (!firstGroupKey) {
        firstGroupKey = key;
      }
    }
  }

  return {
    allMaterialByGroup: allMaterialByGroup,
    allOriginMaterialByGroup: allOriginMaterialByGroup,
    firstGroupKey: firstGroupKey,
  };
}
