let canvas = document.createElement("canvas");
let ctx = canvas.getContext("2d");
ctx.textBaseline = "top";

export function renderPreviewAsset(
  allMaterialList,
  containerScale,
  assetList,
  renderImageAsset,
  renderTextAsset,
) {
  if (!allMaterialList) return null;
  return allMaterialList.map((material, i) => {
    let uiResult = null,
      materialKey = material.assetName,
  
      fontSetting = { ...material.fontSetting },
      imageSrc = assetList[materialKey];
    // let initMaterial = originAllmaterial[i];

    // console.log("------", material)
    let textInit = {};
   
    switch (material.type) {
      case 1:
        uiResult = renderImageAsset(material, containerScale, imageSrc);
        break;

      case 2:
      case 3:
       
        if (
          fontSetting &&
          sessionStorage.getItem("checkAutoSize") !== "closeAutosize"
        ) {
          var minOriginSize = Math.min(...material.originSize);
          material.fontSetting.fontSize =
            minOriginSize > fontSetting.fontSize
              ? fontSetting.fontSize
              : minOriginSize;
        }
        uiResult = renderTextAsset(material, containerScale, textInit);
        break;
      default:
        uiResult = null;
        break;
    }
    return uiResult;
  });
}
